# File backtrack.py
import time, sys
from backtrack0 import Backtrack0

class Backtrack(Backtrack0):

    attempts = 0
    showAttempts = False

    def __init__(self, test:bool = False, showAttempts:bool = False):
        self.test = test
        start = time.time()
        self.attempt(0)
        end = time.time()
        self.showAttempts = showAttempts
        if showAttempts:
            print(f"\n{self.attempts:16_d} attempts"
	          f" in {end-start:8,.2f} seconds")
   
    def attempt(self, level: int) -> bool:        
        if self.attempts>100_000:
            if self.attempts % 5_000_000 == 0:
                print(f"\n{self.attempts//1_000_000:4_d} Millionen ", end="\n")
            
            if self.attempts % 100_000 == 0:
                print(".", sep="", end="")
        
        successful: bool = False
        for move in self.moves(level):
            self.attempts += 1
            if self.test:
                print(f"attempt-test: level:{level}  move:{move}")
            if self.valid(level, move):
                self.record(level, move)
                if self.done(level):
                    successful = True
                    self.undo(level, move)
                    
                else:
                    successful = self.attempt(level+1)
                    if not successful:
                        self.undo(level, move)
