# File backtrack0.py
# Inspiriert von
# https://dl.acm.org/doi/pdf/10.1145/331795.331886

class Backtrack0(object):

    def __init__(self):        
        self.attempt(0)   
    
    def moves(self, level:int):
        raise NotImplementedError()

    def valid(self, level:int, move):
        raise NotImplementedError()

    def record(self, level:int, move):
        raise NotImplementedError()

    def undo(self, level:int, move):
        raise NotImplementedError()

    def done(self, level:int):
        raise NotImplementedError()

    def attempt(self, level: int) -> bool:
        successful: bool = False
        for move in self.moves(level):          
            if self.valid(level, move):
                self.record(level, move)
                if self.done(level):
                    successful = True
                    self.undo(level, move)                    
                else:
                    successful = self.attempt(level+1)
                    if not successful:
                        self.undo(level, move)
