# File queens_2.py
from backtrack import Backtrack

class Queens(Backtrack):

    vector = [ ]
    diag1 =  [ ]  
    diag2 =  [ ]
    resultnumber: int = 0

    def __init__(self, test:bool = False, showAttempts:bool = False,
                 beautify:bool = False, size:int = 8):
        self.beautify = beautify
        self.size = size
        super().__init__(test, showAttempts)
    
    def moves(self, level: int):
        return list(set(range(self.size))-set(self.vector))

    def valid(self, level: int, move:int) -> bool:
        return not(                               # Was ist besetzt...		                  
                     move in self.vector or       # ...die Spalte?   
                     level-move in self.diag1 or  # ...die Diagonale 1: links-oben nach rechts-unten
                     level+move in self.diag2     # ...die Diagonale 2: links-unten nach rechts-oben?  
                  )

    def record(self, level: int, move):
        self.vector.append(move)
        self.diag1.append(level-move)
        self.diag2.append(level+move)
       
    def undo(self, level: int, move):
        self.vector.pop()
        self.diag1.pop()
        self.diag2.pop()

    def done(self, level: int):
        if level==self.size-1:
            self.resultnumber += 1
            print(f"\nLösung {self.resultnumber:4} {self.vector}")            
            if self.beautify:
                self.show()
            return True
        return False

    def show(self):
        # "Schöne" Ausgabe
        for r in range(self.size):
            for c in range(self.size):                        
                print("Q  " if self.vector[r]==c else ".  ", sep="", end="")
            print()

if __name__ == "__main__":
    Queens(test=False, showAttempts=True, beautify=True, size=4)            
